CREATE TABLE logs (
  year int(4) default '0',
  month int(2) default '0',
  day int(2) default '0',
  weekday int(1) default '0',
  dayofyear int(3) default '0',
  isdst int(1) default '0',
  hour int(2) default '0',
  min int(2) default '0',
  sec int(2) default '0',
  host varchar(64) default '',
  service varchar(64) default '',
  status varchar(64) default 'OK',
  status_type varchar(10) default '',
  count int(3) default '0',
  description varchar(255) default '',
  unixts int(14) default '0'
) ENGINE=MyISAM;

ALTER TABLE logs ADD INDEX (unixts);
ALTER TABLE logs ADD INDEX (host);
