<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$where = " WHERE status != 'OK' AND status_type = 'HARD' ";

	$start = $_GET['start'];
	$end   = $_GET['end'];

	if ($start != '' && $end != '')
	{
		$ts_where = "unixts >= '$start' AND unixts < '$end'";
		$where .= ' AND '.$ts_where;
		$ts_where = ' WHERE '.$ts_where;
	}
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<TITLE>Global statistics</TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1>Global statistics</H1>
<? show_period(); ?>

<TABLE>
<?
$query = 'SELECT MIN(unixts) AS first, MAX(unixts) AS latest FROM '.$db_table.' '.$where;
$row = do_fetch($query);
$first_event = $row['first'];
$latest_event = $row['latest'];
?>
<TR><TD ALIGN=RIGHT>First event:</TD><TD><? print date('Y/m/d H:i:s', $first_event); ?></TD></TR>
<TR><TD ALIGN=RIGHT>Latest event:</TD><TD><? print date('Y/m/d H:i:s', $latest_event); ?></TD></TR>
<?
$query = 'SELECT COUNT(*) AS total_n FROM '.$db_table.'  '.$where." AND status_type='HARD'";
$row = do_fetch($query);
$total_n = $row['total_n'];
?>
<?
$query = 'SELECT COUNT(DISTINCT(host)) AS n FROM '.$db_table.' '.$where;
$row = do_fetch($query);
$host_n = $row['n'];
?>
<TR><TD ALIGN=RIGHT>Number of hosts that reported events:</TD><TD><? print $host_n; ?></TD></TR>
<TR><TD ALIGN=RIGHT>Average number of events per host:</TD><TD><? print $total_n / $host_n; ?></TD></TR>
<?
$query = 'SELECT COUNT(DISTINCT(service)) AS n FROM '.$db_table.' '.$where;
$row = do_fetch($query);
$service_n = $row['n'];
?>
<TR><TD ALIGN=RIGHT>Number of services that reported events:</TD><TD><? print $service_n; ?></TD></TR>
<TR><TD ALIGN=RIGHT>Average number of events per service:</TD><TD><? print $total_n / $service_n; ?></TD></TR>
<TR><TD ALIGN=RIGHT>Total number of events:</TD><TD><? print $total_n; ?> (status type 'HARD')</TD></TR>
<TR><TD ALIGN=RIGHT>Average number of seconds between events:</TD><TD><? print ($latest_event - $first_event) / $total_n; ?></TD></TR>
<?
$query = 'SELECT COUNT(DISTINCT(description)) AS n FROM '.$db_table.' '.$where;
$row = do_fetch($query);
?>
<TR><TD ALIGN=RIGHT>Number of unique event-descriptions:</TD><TD><? print $row['n']; ?></TD></TR>
<?
$query = 'SELECT COUNT(*) AS n FROM '.$db_table.' '.$where.' AND (weekday=0 OR weekday=6)';
$row = do_fetch($query);
?>
<TR><TD ALIGN=RIGHT>Number of events in the weekend:</TD><TD><? print $row['n']; ?> (<? print substr(($row['n'] * 100) / $total_n, 0, 5); ?>%)</TD></TR>
<?
$query = 'SELECT COUNT(*) AS n FROM '.$db_table.' '.$where.' AND month=(12-1) AND (day=25 OR day=26)';
$row = do_fetch($query);
?>
<TR><TD ALIGN=RIGHT>Number of events on christmas:</TD><TD><? print $row['n']; ?> (<? print substr(($row['n'] * 100) / $total_n, 0, 5); ?>%)</TD></TR>
</TABLE>

<H2>Events per day</H2>
<IMG SRC="graph_events_per_day.php?start=<? print $start; ?>&end=<? print $end; ?>" BORDER="0"><BR>

<H2># events per status (both SOFT and HARD)</H2>
<TABLE BORDER="1">
<TR><TD><B>Status</B></TD><TD><B># events</B></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $ts_where GROUP BY status) after_where");
$query = "SELECT status, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $ts_where GROUP BY status";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	?><TR><TD><? print $row['status']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TR><?
	$n++;
	$total += $row['n_events'];
	$dtotal += $row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
</TABLE>

<H2># events per status type</H2>
<TABLE BORDER="1">
<TR><TD><B>Status type </B></TD><TD><B># events</B></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $ts_where GROUP BY status_type) after_where");
$query = "SELECT status_type, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $ts_where GROUP BY status_type";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	?><TR><TD><? print $row['status_type']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TR><?
	$n++;
	$total += $row['n_events'];
	$dtotal += $row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
</TABLE>

<?
$what = 'host';
$set = '';
require('per_date.inc.php');
?>

</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>
</BODY>
</HTML>
