<?
	include($jpgraph.'/jpgraph.php');
	include($jpgraph.'/jpgraph_line.php');
	include($jpgraph.'/jpgraph_date.php');

	require 'config.inc.php';

function graph_plot($field, $group_by, $xaxis_is_date)
{
	global $graphs_xres, $graphs_yres, $db_table;

	$where = " WHERE status != 'OK' AND status_type = 'HARD' ";

	if ($_GET['host'] != '')
	{
		$where .= " AND host='".addslashes($_GET['host'])."'";
	}
	$start = $_GET['start'];
	$end   = $_GET['end'];
	if ($start != '' && $end != '')
	{
		$where .= " AND unixts >= '".$start."' AND unixts < '".$end."'";
	}

	$what = $_GET['what'];
	if ($what == '')
	{
		$what = 'host';
	}
	$set = $_GET['set'];
	if ($set != '')
		$where .= ' AND '.$what."='".$set."'";

#	$query = "SELECT AVG($field) AS avg_$field, MIN($field) AS min_$field, MAX($field) AS max_$field, STDDEV($field) AS sd_$field, COUNT(*) AS n_events FROM $db_table $where GROUP BY $group_by";
	$query = "SELECT AVG($field) AS avg_$field, COUNT(*) AS n_events FROM $db_table $where GROUP BY $group_by";

	$results = do_query($query);
	$x_avg_data = array();
	$ydata = array();
	$n = 0;
	while($row = fetch_row($results))
	{
		$x_avg_data[] = $row['avg_'.$field];
#		$x_min_data[] = $row['min_'.$field];
#		$x_max_data[] = $row['max_'.$field];
#		$x_sd_data[]  = $row['sd_' .$field];
		$ydata[] = $row['n_events'];
		$n++;
	}

	$graph = new Graph($graphs_xres, $graphs_yres, 'auto');    

	if ($xaxis_is_date)
	{
		$graph -> SetScale('datlin');
		$graph -> xaxis -> scale -> SetDateFormat('Y/m/d');
		$graph -> SetMargin(40, 20, 30, 70);
	}
	else
	{
		$graph -> SetScale('intlin');
		$graph -> SetMargin(40, 20, 30, 30);
	}
	$graph -> xaxis -> SetLabelAngle(90);

	# average
	$lineplot_avg = new LinePlot($ydata, $x_avg_data);
	$lineplot_avg -> SetColor('blue');
	$graph -> Add($lineplot_avg);

#	# min/max
#	$lineplot_mmin = new LinePlot($ydata, $x_min_data);
#	$lineplot_mmin -> SetColor('green');
#	$graph -> Add($lineplot_mmin);
#	$lineplot_mmax = new LinePlot($ydata, $x_max_data);
#	$lineplot_mmax -> SetColor('red');
#	$graph -> Add($lineplot_mmax);

	$graph -> Stroke();
	exit;
}
?>
