<?
if ($what == '')
{
	$what = 'host';
}
$where = " WHERE status != 'OK' AND status_type = 'HARD' ";
if ($set != '')
{
	$where .= " AND $what='$set'";
}
if ($start != '' && $end != '')
{
	$where .= " AND unixts >= '$start' AND unixts < '$end'";
}
?>

<?
$query = 'SELECT COUNT(*) AS total_n FROM '.$db_table.' '.$where;
$row = do_fetch($query);
$total_n = $row['total_n'];
?>

<?
if ($set != '' && $what != 'service')
{
?>
<H2>Number of events per service</H2>
<TABLE BORDER="1">
<TR><TD><B>Day</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY service) after_where");
$query = "SELECT service, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY service";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR><TD<? print $color; ?>><? print $row['service']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
</TABLE>
<?
}
?>

<H2>Number of events per weekday</H2>
<IMG SRC="graph_events_per_weekday.php?what=<? print enchttp($what); ?>&set=<? if ($set != '') print enchttp($set); ?>&start=<? print $start; ?>&end=<? print $end; ?>" BORDER="0"><BR>
<TABLE BORDER="1">
<TR><TD><B>Day</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY weekday) after_where");
$query = "SELECT weekday, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY weekday";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $weekday[$row['weekday']]; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	print "\n";
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
list($v1, $v2) = trend($where, ' weekday < 3 OR (weekday=3 AND hour < 12)', ' weekday > 3 OR (weekday=3 AND hour >= 12)');
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Trend:</FONT></I></TD><TD><I><FONT SIZE=-1><? print $v2 - $v1; ?></FONT></I></TD></TR>
</TABLE>

<H2>Number of events per week</H2>
<TABLE BORDER="1">
<TR><TD><B>Quarter</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY ".db_week_from_ts(db_ts_from_unixtime('unixts')).") after_where");
$query = "SELECT ".db_week_from_ts(db_ts_from_unixtime('unixts'))." AS week, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY ".db_week_from_ts(db_ts_from_unixtime('unixts'));
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $row['week']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
list($v1, $v2) = trend($where, " ".db_week_from_ts(db_ts_from_unixtime('unixts'))." < 26", " ".db_week_from_ts(db_ts_from_unixtime('unixts'))." >= 26");
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Trend:</FONT></I></TD><TD><I><FONT SIZE=-1><? print $v2 - $v1; ?></FONT></I></TD></TR>
</TABLE>

<H2>Number of events per day of the month</H2>
<IMG SRC="graph_events_per_month.php?what=<? print enchttp($what); ?>&set=<? if ($set != '') print enchttp($set); ?>&start=<? print $start; ?>&end=<? print $end; ?>" BORDER="0"><BR>
<TABLE BORDER="1">
<TR><TD><B>Day</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch('SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM '.$db_table.' '.$where.' GROUP BY day) after_where');
$query = "SELECT day, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY day";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $row['day']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
list($v1, $v2) = trend($where, ' day < 16', ' day >= 16');
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Trend:</FONT></I></TD><TD><I><FONT SIZE=-1><? print $v2 - $v1; ?></FONT></I></TD></TR>
</TABLE>

<H2>Number of events per quarter</H2>
<TABLE BORDER="1">
<TR><TD><B>Quarter</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY ".db_quarter_from_ts(db_ts_from_unixtime('unixts')).") after_where");
$query = "SELECT ".db_quarter_from_ts(db_ts_from_unixtime('unixts'))." AS quarter, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY ".db_quarter_from_ts(db_ts_from_unixtime('unixts'));
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $row['quarter']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
list($v1, $v2) = trend($where, " ".db_quarter_from_ts(db_ts_from_unixtime('unixts'))." <= 1", " ".db_quarter_from_ts(db_ts_from_unixtime('unixts'))." >= 2");
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Trend:</FONT></I></TD><TD><I><FONT SIZE=-1><? print $v2 - $v1; ?></FONT></I></TD></TR>
</TABLE>

<H2>Number of events per year</H2>
<TABLE BORDER="1">
<TR><TD><B>Year</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY year) after_where");
$query = "SELECT year, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY year";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $row['year'] + 1900; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
</TABLE>

<H2>Number of events per hour</H2>
<IMG SRC="graph_events_per_hour.php?what=<? print enchttp($what); ?>&set=<? if ($set != '') print enchttp($set); ?>&start=<? print $start; ?>&end=<? print $end; ?>" BORDER="0"><BR>
<TABLE BORDER="1">
<TR><TD><B>Hour</B></TD><TD><B># events</B></TD><TD></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY hour) after_where");
$query = "SELECT hour, COUNT(*) AS n_events, ((COUNT(*) * 100.0) / $total_n) AS percentage FROM $db_table $where GROUP BY hour";
$results = do_query($query);
$n = $total = $dtotal = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $row['hour']; ?></TD><TD><? print $row['n_events']; ?></TD><TD><? print $row['percentage']; ?>%</TD></TR><?
	$n++;
	$total+=$row['n_events'];
	$dtotal+=$row['n_events'] * $row['n_events'];
}
$avg = $total / $n;
$dev = sqrt(($dtotal / $n) - ($avg * $avg));
list($v1, $v2) = trend($where, ' hour < 12', ' hour >= 12');
?>
<TR><TD COLSPAN="3" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev); ?></FONT></I></TD></TR>
<TR><TD><I><FONT SIZE=-1>Trend:</FONT></I></TD><TD><I><FONT SIZE=-1><? print $v2 - $v1; ?></FONT></I></TD></TR>
</TABLE>
