<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$start = $_GET['start'];
	$end   = $_GET['end'];

	$period_duration = 0;
	if ($start != '' && $end != '')
	{
		$where = "WHERE unixts >= '$start' AND unixts < '$end'";
		$period_duration = $end - $start;
	}

function emit_data($force_host_end)
{
	global $prev_host, $prev_service, $cnt, $total, $host_total, $host_cnt, $host, $service, $period_duration, $start, $end;

	if ($cnt > 0)
	{
		print "<TR><TD><A HREF=\"descriptions_list.php?start=$start&end=$end&what=host&host=".enchttp($prev_host)."\">$prev_host</A></TD><TD><A HREF=\"descriptions_list.php?start=$start&end=$end&what=set&set=".enchttp($prev_service)."\">$prev_service</A></TD><TD>$cnt</TD><TD>".n_sec_to_hms($total).'</TD><TD>'.n_sec_to_hms($total / $cnt).'</TD>';
		if ($period_duration)
			print '<TD>'.substr(($total * 100.0) / $period_duration, 0, 6).'%</TD>';
		print "</TR>\n";

		if ($host != $prev_host || $force_host_end)
		{
			print "<TR><TD><!-- host --></TD><TD><!-- service --></TD><TD><I>$host_cnt<I></TD><TD><I>".n_sec_to_hms($host_total).'</I></TD><TD><I>'.n_sec_to_hms($host_total / $host_cnt)."</I></TD>\n";
			if ($period_duration)
				print '<TD>'.substr(($host_total * 100.0) / $period_duration, 0, 6).'%</TD>';
			print "</TR>\n";

			$host_total = $host_cnt = 0;
		}

		$cnt = $total = 0;
	}
}
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<TITLE>Problem duration totals</TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1>Problem duration totals</H1>
<? show_period(); ?>

<TABLE BORDER="1">
<TR><TD><B>host</B></TD><TD><B>service</B></TD><TD><B>problem count</B></TD><TD><B>total downtime</B></TD><TD><B>average downtime</B></TD><?
if ($period_duration)
{
	?><TD><B>percentage of period</B></TD><?
} ?></TR>
<?
$query = "SELECT unixts, host, service, status FROM $db_table $where ORDER BY host, service, unixts";
$done = 0;
$prev_host = $prev_service = '';
$results = do_query($query);
do
{
	$first = 1;
	$t1 = $t2 = -1;

	do
	{
		$row = fetch_row($results);
		if (!$row)
		{
			$done = 1;
			break;
		}

		$status = $row['status'];

		if ($first == 1 || $row['host'] != $host || $row['service'] != $service)
		{
			$host = $row['host'];
			$service = $row['service'];
			$t1 = $row['unixts'];
			if (!$first)
				$not_complete++;
			$first = 0;
		}
		else
		{
			$t2 = $row['unixts'];
		}
	}
	while($status != 'OK');

	if ($done == 0)
	{
		if ($prev_host != $host || $prev_service != $service)
		{
			emit_data(0);

			$prev_host = $host;
			$prev_service = $service;
		}

		if ($t2 != -1 && $t1 != -1)	# in case we only got an 'OK' and no problem
		{
			$td = $t2 - $t1;

			$cnt++;
			$total += $td;

			$host_cnt++;
			$host_total += $td;

			$global_cnt++;
			$global_total += $td;
		}
	}
}
while(!$done);

emit_data(1);
?>
</TABLE>

<TABLE>
<TR><TD ALIGN="RIGHT">Total number of problems:</TD><TD><? print $global_cnt; ?></TD></TR>
<TR><TD ALIGN="RIGHT">Total duration:</TD><TD><? print n_sec_to_hms($global_total); ?></TD></TR>
<TR><TD ALIGN="RIGHT">Average:</TD><TD><? print n_sec_to_hms($global_total / $global_cnt); ?></TD></TR>
</TABLE>

</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>
</BODY>
</HTML>
