CREATE TABLE logs (
  year smallint default '0',
  month smallint default '0',
  day smallint default '0',
  weekday smallint default '0',
  dayofyear smallint default '0',
  isdst smallint default '0',
  hour smallint default '0',
  min smallint default '0',
  sec smallint default '0',
  host varchar(64) default '',
  service varchar(64) default '',
  status varchar(64) default 'OK',
  status_type varchar(10) default '',
  count integer default '0',
  description varchar(255) default '',
  unixts integer default '0'
);

CREATE INDEX ON logs (unixts);
CREATE INDEX ON logs (host);
