<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$where = " WHERE status != 'OK' AND status_type = 'HARD' ";

	if ($_GET['what'] == 'set')
	{
		$column1 = 'host';
		$column1_descr = 'Host';

		if ($_GET['set'] != '')
		{
			$where .= " AND service='".addslashes($_GET['set'])."'";
			$for = " for service '".$_GET['set']."'";
		}
	}
	else
	{
		$column1 = 'service';
		$column1_descr = 'Service';

		if ($_GET['host'] != '')
		{
			$where .= " AND host='".addslashes($_GET['host'])."'";
			$for = " for host '".$_GET['host']."'";
		}
	}
	$start = $_GET['start'];
	$end   = $_GET['end'];
	if ($start != '' && $end != '')
		$where .= " AND unixts >= '$start' AND unixts < '$end'";

	if ($_GET['status_type'] == 'SOFT')
		$where .= " AND status_type='SOFT'";
	else
		$where .= " AND status_type='HARD'";

	$order = 'n_events';
	if ($_GET['order'] == $column1)
		$order = $column1;
	else if ($_GET['order'] == 'description')
		$order = 'description';
	else if ($_GET['order'] == 'n_events')
		$order = 'n_events';

	if ($_GET['order_dir'] == 'desc')
	{
		$new_order_dir = 'asc';
		$order_dir = 'desc';
	}
	else
	{
		$new_order_dir = 'desc';
		$order_dir = 'asc';
	}

function url($column, $description)
{
	global $new_order_dir;

	?><A HREF="descriptions_list.php?order=<? print strtolower($column);
	?>&order_dir=<? print $new_order_dir;
	?>&what=<? print $_GET['what'];
	?>&start=<? print $_GET['start'];
	?>&end=<? print $_GET['end'];
	if ($_GET['what'] == 'set')
		print '&set='.enchttp($_GET['set']);
	else
		print '&host='.$_GET['host'];
	?>"><? print $description; ?></A><?
}
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<?
	$heading = 'List of service descriptions '.$for;
	if ($_GET['status_type'] == 'SOFT')
		$heading .= ' (SOFT)';
	else
		$heading .= ' (HARD)';
?>
<TITLE><? print $heading; ?></TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1><? print $heading; ?></H1>
<? show_period(); ?>
<TABLE BORDER="1">
<TR><TD><B><? url($column1, $column1_descr); ?></B></TD><TD><B><? url('description', 'Description'); ?></B></TD><TD><B><? url('n_events', '# events'); ?></B></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY $column1, description) after_where");
$query = "SELECT $column1, description, COUNT(*) AS n_events FROM $db_table $where GROUP BY $column1, description ORDER BY $order $order_dir";
$results = do_query($query);
$n = $tot_n_events = $dtot_n_events = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>><TD><? print $row[$column1]; ?></TD><TD><? print $row['description']; ?></TD><TD><? print $row['n_events']; ?></TD></TR><?
	$tot_n_events += $row['n_events'];
	$dtot_n_events += $row['n_events'] * $row['n_events'];
	$n++;
}
$avg_n_events = $tot_n_events / $n;
$dev_n_events = sqrt(($dtot_n_events / $n) - ($avg_n_events * $avg_n_events));
?>
<TR><TD COLSPAN="8" HEIGHT="4"></TD></TR>
<TR><TD></TD><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg_n_events); ?></FONT></I></TD><TR>
<TR><TD></TD><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev_n_events); ?></FONT></I></TD><TR>
</TABLE>

</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>
</BODY>
</HTML>
