<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$where = " WHERE status != 'OK' AND status_type = 'HARD' ";

	if ($_GET['start'] != '' && $_GET['end'] != '')
		$where .= " AND unixts >= '".addslashes($_GET['start'])."' AND unixts < '".addslashes($_GET['end'])."'";

	if ($_GET['what'] == 'service')
		$what = 'service';
	else
		$what = 'host';

	$order = $what;
        if ($_GET['order'] == 'host')
                $order = 'host';
        else if ($_GET['order'] == 'service')
                $order = 'service';
        else if ($_GET['order'] == 'n_events')
                $order = 'n_events';
        else if ($_GET['order'] == 'first')
                $order = 'first';
        else if ($_GET['order'] == 'last')
                $order = 'last';
        else if ($_GET['order'] == 'n_days')
                $order = 'n_days';
        else if ($_GET['order'] == 'average')
                $order = 'average';

        if ($_GET['order_dir'] == 'desc')
        {
                $new_order_dir = 'asc';
                $order_dir = 'desc';
        }
        else
        {
                $new_order_dir = 'desc';
                $order_dir = 'asc';
        }

function url($column, $description)
{
        global $new_order_dir;

        ?><A HREF="stats_list.php?order=<? print strtolower($column);
	?>&what=<? print $_GET['what'];
        ?>&order_dir=<? print $new_order_dir;
        ?>&start=<? print $_GET['start'];
        ?>&end=<? print $_GET['end'];
        ?>"><? print $description; ?></A><?
}
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<TITLE>Statistics per <? print $what; ?></TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1>Statistics per <? print $what; ?></H1>
<?
show_period();

if ($_GET["start"] != "")
	print '> <A HREF="correlate_field.php?start='.$_GET['start'].'&end='.$_GET['end'].'&field='.$what.'">Correlate</A><BR><BR>';
else
	print '> <A HREF="correlate_field.php?field='.$what.'">Correlate</A><BR><BR>';
?>

<TABLE BORDER="1">
<TR><TD><B><? url($what, strtoupper(substr($what, 0, 1)).substr($what, 1)); ?></B></TD><TD><B><? url('n_events', '# events'); ?></B></TD><TD><B><? url('first', 'First event'); ?></B></TD><TD><B><? url('last', 'Last event'); ?></B></TD><TD><B><? url('n_days', '# days'); ?></B></TD><TD><B><? url('average', 'Average # events/day'); ?></B></TD></TR>
<?
$as_row = do_fetch("SELECT AVG(after_where.nr) AS avg, STDDEV(after_where.nr) AS stddev FROM (SELECT COUNT(*) AS nr FROM $db_table $where GROUP BY $what) after_where");
$query = "SELECT $what, COUNT(*) AS n_events, MIN(unixts) AS first, MAX(unixts) AS last, (MAX(unixts) - MIN(unixts)) / 86400 AS n_days, CASE WHEN ((MAX(unixts) - MIN(unixts)) / 86400) > 1 THEN (COUNT(*) * 86400) / (MAX(unixts) - MIN(unixts)) ELSE COUNT(*) END AS average FROM $db_table $where GROUP BY $what ORDER BY $order $order_dir";
$results = do_query($query);
$tot_n_events = 0;
$tot_n_days = 0;
$tot_average = 0;
$dtot_n_events = 0;
$dtot_n_days = 0;
$dtot_average = 0;
$n = 0;
while($row = fetch_row($results))
{
	$color = get_color($row['n_events'], $as_row['avg'], $as_row['stddev']);
	?><TR<? print $color; ?>>
	<TD><? print $row[$what]; ?></TD>
	<TD><? print $row['n_events']; ?></TD>
	<TD><? print strftime('%Y/%m/%d %H:%M:%S', $row['first']); ?></TD>
	<TD><? print strftime('%Y/%m/%d %H:%M:%S', $row['last']); ?></TD>
	<TD><? print $row['n_days']; ?></TD>
	<TD><? print $row['average']; ?></TD>
	<TD><A HREF="descriptions_list.php?what=<? if ($what == 'service') print 'set'; else print 'host'; ?>&<? if ($what == 'service') print 'set'; else print 'host'; ?>=<? print enchttp($row[$what]); ?>&start=<? print $_GET['start']; ?>&end=<? print $_GET['end']; ?>">what</A></TD>
	<TD><A HREF="stats_per_<? print $what; ?>.php?set=<? print enchttp($row[$what]); ?>&start=<? print $_GET['start']; ?>&end=<? print $_GET['end']; ?>">when</A></TD>
	</TR><?

	$tot_n_events += $row['n_events'];
	$tot_n_days += $row['n_days'];
	$tot_average += $row['average'];
	$dtot_n_events += $row['n_events'] * $row['n_events'];
	$dtot_n_days += $row['n_days'] * $row['n_days'];
	$dtot_average += $row['average'] * $row['average'];
	$n++;
}
$avg_n_events = $tot_n_events / $n;
$avg_n_days = $tot_n_days / $n;
$avg_average = $tot_average / $n;
$dev_n_events = sqrt(($dtot_n_events / $n) - ($avg_n_events * $avg_n_events));
$dev_n_days = sqrt(($dtot_n_days / $n) - ($avg_n_days * $avg_n_days));
$dev_average = sqrt(($dtot_average / $n) - ($avg_average * $avg_average));
?>
<TR><TD COLSPAN="8" HEIGHT="4"></TD></TR>
<TR><TD><I><FONT SIZE=-1>Average:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg_n_events); ?></FONT></I></TD><TD></TD><TD></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg_n_days); ?></FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $avg_average); ?></FONT></I></TD><TD></TD><TD></TD></TR>
<TR><TD><I><FONT SIZE=-1>Std.dev.:</FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev_n_events); ?></FONT></I></TD><TD></TD><TD></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev_n_days); ?></FONT></I></TD><TD><I><FONT SIZE=-1><? printf('%.2f', $dev_average); ?></FONT></I></TD><TD></TD><TD></TD></TR>
</TABLE>

</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>
</BODY>
</HTML>
